"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const router_1 = require("@angular/router");
const oaf_routing_1 = require("oaf-routing");
exports.defaultSettings = Object.assign({}, oaf_routing_1.defaultSettings);
exports.wrapRouter = (router, settingsOverrides) => {
    const settings = Object.assign({}, exports.defaultSettings, { 
        // TODO support pop page state restoration.
        restorePageStateOnPop: false, 
        // We're not restoring page state ourselves so leave this enabled.
        disableAutoScrollRestoration: false }, settingsOverrides);
    const oafRouter = oaf_routing_1.createOafRouter(settings, navigation => navigation.extractedUrl.fragment || "");
    const initialNavigation = router.getCurrentNavigation();
    if (initialNavigation !== null) {
        oafRouter.handleFirstPageLoad(initialNavigation);
    }
    const subscription = router.events.subscribe(event => {
        if (event instanceof router_1.NavigationEnd) {
            const navigation = router.getCurrentNavigation();
            const previousNavigation = navigation !== null ? navigation.previousNavigation : null;
            if (navigation !== null && previousNavigation !== null) {
                oafRouter.handleLocationChanged(previousNavigation, navigation, undefined, undefined);
            }
        }
    });
    return () => {
        oafRouter.resetAutoScrollRestoration();
        subscription.unsubscribe();
    };
};
